--[[
LuCI support for dj
Copyright (C) 2010-2011 Thinktube Inc
]]--

m = Map("dj", translate("dj_alert_title"), translate("dj_description"))

---- alert ----
alert = m:section(TypedSection, "alert", translate("dj_section_alert"), "")
alert.anonymous = true

host = alert:option(Value, "server_host", translate("dj_host"))
port = alert:option(Value, "server_port", translate("dj_port"))
l_port = alert:option(Value, "local_port", translate("dj_local_port"))

a10_en = alert:option(Flag, "a10_enabled", translate("dj_a10_enabled"))
a10_val = alert:option(Value, "a10_param", translate("dj_a10_param"), translate("minutes", "Minutes"))

a11_en = alert:option(Flag, "a11_enabled", translate("dj_a11_enabled"))
a11_val = alert:option(Value, "a11_param", translate("dj_a11_param"), translate("minutes", "Minutes"))

a12_en = alert:option(Flag, "a12_enabled", translate("dj_a12_enabled"))

a13_en = alert:option(Flag, "a13_enabled", translate("dj_a13_enabled"))

a14_en = alert:option(Flag, "a14_enabled", translate("dj_a14_enabled"))
a14_val = alert:option(Value, "a14_param", translate("dj_a14_param"))

a15_en = alert:option(Flag, "a15_enabled", translate("dj_a15_enabled"))

a20_en = alert:option(Flag, "a20_enabled", translate("dj_a20_enabled"))
a21_en = alert:option(Flag, "a21_enabled", translate("dj_a21_enabled"))

a30_en = alert:option(Flag, "a30_enabled", translate("dj_a30_enabled"))
a31_en = alert:option(Flag, "a31_enabled", translate("dj_a31_enabled"))

------------------------------- validater ------------------------------
function validate_value(self, value, _min, _max)
	local min_val = _min
	local max_val = _max
	local v = tonumber(value)

	if not min_val then
		min_val = 0
	end
	if not max_val then
		max_val = 65535
	end
	if v and v >= min_val and v <= max_val then
		return value
	else
		self.err_message = translate("error_value", "Error") ..
				" (" .. translate("min") .. " " .. tostring(min_val) .. ", " ..
				translate("max") .. " " .. tostring(max_val) .. ")"
		return nil
	end
end

function validate_a10(self, value)
	return validate_value(self, value, 1, 60)
end

function validate_a11(self, value)
	return validate_value(self, value, 1, 60)
end
function validate_a14(self, value)
	return validate_value(self, value, 2, 65535)
end

a10_val.validate = validate_a10
a11_val.validate = validate_a11
a14_val.validate = validate_a14

return m
